%% TD3 - Localisation et Navigation de Robots
%%
%% Exercice 1: Creer et deplacer un robot mobile

clear
close all
clc 

% Creer un robot "veh" avec une matrice de covariance odometrique (distance parcourue, 
% variation de l'orientation) et afficher son etat initial
veh = Vehicle(diag([0.1, 1*pi/180].^2)) 

% Utiliser la fonction "update" pour appliquer une vitesse de 0.2 m/s 
% avec une orientation de 0.1 rad pour un pas de temps. 
% Afficher la nouvelle position du robot
odo = veh.update([0.2, 0.1]);

% "odo" represente l'estimation odometrique bruyante

% Attacher un pilote ("driver") au robot pour le faire deplacer suivant 
% une trajectoire aleatoire dans une region -10 < x < 10, -10 < y < 10 metres
veh.add_driver(RandomPath(10))

% Visualiser le mouvement du robot en utilisant l'option "run" pour N = 1000 instants, 
% et recuperer l'etat instantane [x, y, theta]' du robot
N = 1000;
veh.run(N)

veh.plot_xy
xlabel('x [m]')
ylabel('y [m]')
title('Ex. 1: Création et déplacement d''un robot')